<?php

defined('_JEXEC') or die('Restricted access');

class CrossfitControllerImporter extends JControllerLegacy {

    public function getModel($name = 'Subscriptions', $prefix = 'CrossfitModel', $config = array('ignore_request' => true)) {
        return parent::getModel($name, $prefix, $config);
    }

    public function import() {
        // sju9l _5 => Monza => idLocation = 2
        ob_start();
        echo "<pre>";
        ini_set('display_errors', 1);
        ini_set('display_startup_errors', 1);
        error_reporting(E_ALL);
        $dbMEDA = JDatabaseDriver::getInstance(array(
                    'driver' => 'mysqli',
                    'host' => '89.46.111.44',
                    'user' => 'Sql1099189',
                    'password' => '85r05tw5y0',
                    'database' => 'Sql1099189_4',
                    'prefix' => 'dv0qk_'
        ));
        $dbMONZA = JDatabaseDriver::getInstance(array(
                    'driver' => 'mysqli',
                    'host' => '89.46.111.44',
                    'user' => 'Sql1099189',
                    'password' => '85r05tw5y0',
                    'database' => 'Sql1099189_5',
                    'prefix' => 'sju9l_'
        ));
        $dbCROSS = JFactory::getDBO();

        $dbCROSS->setQuery("TRUNCATE #__rseventspro_events;")->execute();
        $dbCROSS->setQuery("TRUNCATE #__rseventspro_taxonomy;")->execute();
        $dbCROSS->setQuery("TRUNCATE #__rseventspro_users;")->execute();
        $dbCROSS->setQuery("TRUNCATE #__crossfit_users;")->execute();
        $dbCROSS->setQuery("TRUNCATE #__crossfit_memberships;")->execute();
        $dbCROSS->setQuery("TRUNCATE #__crossfit_subscriptions;")->execute();
        $dbCROSS->setQuery("TRUNCATE #__crossfit_subscriptions_users;")->execute();


        $EVENTMAPMONZA = $this->map_events($dbMONZA, $dbCROSS, 2);
        $this->map_events_taxonomy($dbMONZA, $dbCROSS, $EVENTMAPMONZA, array(
            11 => 10, 19 => 11, 20 => 12, 21 => 13, 22 => 14, 23 => 15, 24 => 16, 13 => 17, 17 => 18, 14 => 19
        ));
        $USERSMAPMONZA = $this->map_users($dbMONZA, $dbCROSS, 2, 10);
        $this->insert_iscrizioni($dbMONZA, $dbCROSS, $EVENTMAPMONZA, $USERSMAPMONZA['joomla']);
        $this->memberships($dbMONZA, $dbCROSS, $USERSMAPMONZA['crossfit']);
        $MAPSUBSCRIPTIONSMONZA = $this->insert_subscriptions($dbMONZA, $dbCROSS, " - MONZA");
        $this->map_users_subscriptions($dbMONZA, $dbCROSS, $USERSMAPMONZA['crossfit'], $MAPSUBSCRIPTIONSMONZA);
        

        $EVENTMAPMEDA = $this->map_events($dbMEDA, $dbCROSS, 3);
        $this->map_events_taxonomy($dbMEDA, $dbCROSS, $EVENTMAPMEDA, array(
            39 => 17, 42 => 20, 43 => 21, 45 => 22, 46 => 23, 47 => 24, 48 => 25, 40 => 26, 41 => 27, 44 => 28
        ));
        $USERSMAPMEDA = $this->map_users($dbMEDA, $dbCROSS, 3, 10);
        $this->insert_iscrizioni($dbMEDA, $dbCROSS, $EVENTMAPMEDA, $USERSMAPMEDA['joomla']);
        $this->memberships($dbMEDA, $dbCROSS, $USERSMAPMEDA['crossfit']);
        $MAPSUBSCRIPTIONSMEDA = $this->insert_subscriptions($dbMEDA, $dbCROSS, " - MEDA");
        $this->map_users_subscriptions($dbMEDA, $dbCROSS, $USERSMAPMEDA['crossfit'], $MAPSUBSCRIPTIONSMEDA);

        exit;
    }

    public function map_users_subscriptions($DBOrigine, $DBdestinazione, $USERSMAP, $MAPSUBSCRIPTIONS) {

        $subscriptions = $DBOrigine->setQuery("SELECT * FROM #__crossfit_subscriptions_users")->loadObjectList();
        if ($subscriptions) {
            foreach ($subscriptions as $subscription) {
                if (!isset($USERSMAP[$subscription->idUser]) || !isset($MAPSUBSCRIPTIONS[$subscription->idSubscription])) {
                    continue;
                }
                $newOBJC = clone $subscription;
                unset($newOBJC->idSU);
                $newOBJC->idUser = $USERSMAP[$subscription->idUser];
                $newOBJC->idSubscription = $MAPSUBSCRIPTIONS[$subscription->idSubscription];
                $newOBJC->allenamentoAggiuntivo = 1;

                if (!$DBdestinazione->insertObject("#__crossfit_subscriptions_users", $newOBJC, 'idSU')) {
                    die("Error1: " . print_R($newOBJC, true));
                }
            }
        }
    }

    public function insert_subscriptions($DBOrigine, $DBdestinazione, $SUFFIX = "") {
        $MAPSUBSCRIPTIONS = array();

        $subscriptions = $DBOrigine->setQuery("SELECT * FROM #__crossfit_subscriptions")->loadObjectList();
        if ($subscriptions) {
            foreach ($subscriptions as $subscription) {
                $newOBJC = clone $subscription;
                unset($newOBJC->idSubscription);
                $newOBJC->nome .= $SUFFIX;

                if (!$DBdestinazione->insertObject("#__crossfit_subscriptions", $newOBJC, 'idSubscription')) {
                    die("Error2: " . print_R($newOBJC, true));
                }

                $MAPSUBSCRIPTIONS[$subscription->idSubscription] = $DBdestinazione->insertid();
            }
        }

        return $MAPSUBSCRIPTIONS;
    }

    public function memberships($DBOrigine, $DBdestinazione, $USERSMAP) {

        $memberships = $DBOrigine->setQuery("SELECT * FROM #__crossfit_memberships")->loadObjectList();
        if ($memberships) {
            foreach ($memberships as $membership) {
                if (!isset($USERSMAP[$membership->idUser])) {
                    continue;
                }
                $newOBJ = clone $membership;
                unset($newOBJ->idMembership);
                $newOBJ->idUser = $USERSMAP[$membership->idUser];

                if (!$DBdestinazione->insertObject("#__crossfit_memberships", $newOBJ, 'idMembership')) {
                    die("Error3: " . print_R($newOBJ, true));
                }
            }
        }
    }

    public function map_users($DBOrigine, $DBdestinazione, $idPalestra, $GRUPPOCROSSFIT) {
        $CRUSERMAP = array();
        $JOUSERMAP = array();
        jimport('joomla.user.helper');

        $users = $DBOrigine->setQuery("SELECT * FROM #__crossfit_users")->loadObjectList();
        if ($users) {
            foreach ($users as $user) {
                $newOBJ = clone $user;
                unset($newOBJ->idUser);

                $idUSER = JUserHelper::getUserId($newOBJ->username);
                if ($idUSER) {
                    $toDel = new JUser($idUSER);
                    $toDel->delete();
                }

                $data = array(
                    "name" => $newOBJ->nome . " " . $newOBJ->cognome,
                    "username" => $newOBJ->username,
                    "password" => $newOBJ->username,
                    "password2" => $newOBJ->username,
                    "email" => $newOBJ->email,
                    "block" => 0,
                    "groups" => array($GRUPPOCROSSFIT)
                );

                $Nuser = new JUser;
                if (!$Nuser->bind($data)) {
                    throw new Exception("Could not bind data. Error: " . $user->getError());
                }
                if (!$Nuser->save()) {
                    throw new Exception("Could not save user. Error: " . $user->getError());
                }
                $JOUSERMAP[$newOBJ->idUserJoomla] = $Nuser->id;

                $password = $DBOrigine->setQuery("SELECT password FROM #__users WHERE id = '{$newOBJ->idUserJoomla}'")->loadResult();
                $DBdestinazione->setQuery("UPDATE #__users SET password = " . $DBdestinazione->quote($password) . " WHERE id = {$Nuser->id}")->execute();

                $newOBJ->idPalestra = $idPalestra;
                $newOBJ->idUserJoomla = $Nuser->id;
                if (!$DBdestinazione->insertObject("#__crossfit_users", $newOBJ, 'idUser')) {
                    die("Error4: " . print_R($newOBJ, true));
                }

                $insertedID = $DBdestinazione->insertid();
                $CRUSERMAP[$user->idUser] = $insertedID;
            }
        }

        return array('crossfit' => $CRUSERMAP, 'joomla' => $JOUSERMAP);
    }

    public function insert_iscrizioni($DBOrigine, $DBdestinazione, $EVENTMAP, $USERMAP) {
        if ($EVENTMAP) {
            foreach ($EVENTMAP as $oldID => $newID) {
                $iscrizioni = $DBOrigine->setQuery("SELECT * FROM #__rseventspro_users WHERE ide = {$oldID}")->loadObjectList();
                if ($iscrizioni) {
                    foreach ($iscrizioni as $iscrizione) {
                        if (!isset($USERMAP[$iscrizione->idu])) {
                            continue;
                        }
                        $newOBJ = clone $iscrizione;
                        unset($newOBJ->id);
                        $newOBJ->ide = $newID;
                        $newOBJ->idu = $USERMAP[$newOBJ->idu];

                        if (!$DBdestinazione->insertObject("#__rseventspro_users", $newOBJ)) {
                            die("Error5: " . print_R($newOBJ, true));
                        }
                    }
                }
            }
        }
    }

    public function map_events_taxonomy($DBOrigine, $DBdestinazione, $EVENTMAP, $TAXMAP) {
        if ($EVENTMAP) {
            foreach ($EVENTMAP as $oldID => $newID) {
                $taxes = $DBOrigine->setQuery("SELECT * FROM #__rseventspro_taxonomy WHERE type = 'category' AND ide = {$oldID}")->loadObjectList();
                if ($taxes) {
                    foreach ($taxes as $tax) {
                        if (isset($TAXMAP[$tax->id])) {
                            $newOBJ = clone $tax;
                            $newOBJ->ide = $newID;
                            $newOBJ->id = $TAXMAP[$tax->id];

                            if (!$DBdestinazione->insertObject("#__rseventspro_taxonomy", $newOBJ)) {
                                die("Error6: " . print_R($newOBJ, true));
                            }
                        }
                    }
                }
            }
        }
    }

    public function map_events($DBOrigine, $DBdestinazione, $IDLocation) {
        $EVENTMAP = array();

        $eventiP = $DBOrigine->setQuery("SELECT * FROM #__rseventspro_events WHERE parent = 0")->loadObjectList();
        if ($eventiP) {
            foreach ($eventiP as $event) {
                $newOBJ = clone $event;
                unset($newOBJ->id);
                $newOBJ->location = $IDLocation;
                $newOBJ->owner = 298;

                if (!$DBdestinazione->insertObject("#__rseventspro_events", $newOBJ, 'id')) {
                    die("Error8: " . print_R($newOBJ, true));
                }

                $insertedID = $DBdestinazione->insertid();
                $EVENTMAP[$event->id] = $insertedID;

                $eventiC = $DBOrigine->setQuery("SELECT * FROM #__rseventspro_events WHERE parent = {$event->id}")->loadObjectList();
                if ($eventiC) {
                    foreach ($eventiC as $eventC) {
                        $newOBJC = clone $eventC;
                        unset($newOBJC->id);
                        $newOBJC->parent = $insertedID;
                        $newOBJC->location = $IDLocation;
                        $newOBJC->owner = 298;

                        if (!$DBdestinazione->insertObject("#__rseventspro_events", $newOBJC, 'id')) {
                            die("Error7: " . print_R($newOBJ, true));
                        }

                        $EVENTMAP[$eventC->id] = $DBdestinazione->insertid();
                    }
                }
            }
        }

        return $EVENTMAP;
    }

}
