<?php
defined('_JEXEC') or die;
JHtml::_('behavior.formvalidator');

$document = JFactory::getDocument();
$document->addScriptDeclaration('
    jQuery(function($) {
            if($("#jformSubscription_dataInizioS").val() != "") {
                    calculateEndDate();
            }
            calulateSaldo();
        $(document).bind("change paste", "#jformSubscription_giorniAggiuntivi, #jformSubscription_sospeso, #jformSubscription_giorniSospensione", function(){
            calculateEndDate();
        });
        $(document).bind("change paste", "#jformSubscription_prezzo, #jformSubscription_pagatoS", function(){
            calulateSaldo();
        });
        $(document).on("click", ".calendar .day", function(){
            calculateEndDate();
        });
        
        if($("#jformSubscription_idSubscription").find("option:selected").data("ingressitotali")) {
            $("#jformSubscription_dataScadenzaS").parents(".control-group").hide();
            $("#jformSubscription_giorniAggiuntivi").parents(".control-group").hide();
            $("#jformSubscription_dataScadenzaReale").parents(".control-group").show();  
        } else {
            $("#jformSubscription_dataScadenzaS").parents(".control-group").show();
            $("#jformSubscription_giorniAggiuntivi").parents(".control-group").show();
            $("#jformSubscription_dataScadenzaReale").parents(".control-group").hide();
        }
    
        $(document).on("change", "#jformSubscription_idSubscription", function(){
            if($(this).find("option:selected").data("ingressitotali")) {
                $("#jformSubscription_dataScadenzaS").parents(".control-group").hide();
                $("#jformSubscription_giorniAggiuntivi").parents(".control-group").hide();
                $("#jformSubscription_dataScadenzaReale").parents(".control-group").show();        
            } else {
                $("#jformSubscription_dataScadenzaS").parents(".control-group").show();
                $("#jformSubscription_giorniAggiuntivi").parents(".control-group").show();
                $("#jformSubscription_dataScadenzaReale").parents(".control-group").hide();

            }
        });
    });

    function calculateEndDate() {
        if(jQuery("#jformSubscription_dataInizioS").val() == "") return;
        var mesi                = parseInt(jQuery("#jformSubscription_idSubscription option:selected").data("mesi")) || 0;
        var giorniAggiuntivi    = parseInt(jQuery("#jformSubscription_giorniAggiuntivi").val()) || 0;
        var giorniSospensione   = parseInt(jQuery("#jformSubscription_giorniSospensione").val()) || 0;

        var data = jQuery("#jformSubscription_dataInizioS").val();
        data = data.split("/");
        data = new Date(data[2] + "-" + data[1] + "-" + data[0]);

        data.setMonth(data.getMonth() + mesi);
        data.setDate(data.getDate() + giorniAggiuntivi);
        data.setDate(data.getDate() + giorniSospensione);

        var newYear = data.getFullYear(), newMonth = data.getMonth()+1, newDate = data.getDate();

        newDate     = (newDate < 10 ? "0" + newDate : newDate);
        newMonth    = (newMonth < 10 ? "0" + newMonth : newMonth);

        jQuery("#jformSubscription_dataScadenzaS").val(newDate + "/" + newMonth + "/" + newYear);
    }

    function calulateSaldo() {
        var saldoTotale = parseInt(jQuery("#jformSubscription_prezzo").val()) || 0;
        var saldoNuovo  = parseInt(jQuery("#jformSubscription_pagatoS").val()) || 0;

        jQuery("#jformSubscription_daPagare").val(saldoTotale - saldoNuovo);
    }
');
?>

<form class="form-validate" action="index.php?option=com_crossfit&view=user&layout=edit" method="post" id="adminForm" name="adminForm">
    <div class="form-horizontal">
        <fieldset class="adminform">
            <div class="row-fluid">
                <div class="span6">
                    <?php foreach ($this->form->getFieldset() as $field): ?>
                        <div class="control-group">
                            <div class="control-label"><?php echo $field->label; ?></div>
                            <div class="controls"><?php echo $field->input; ?></div>
                        </div>
                    <?php endforeach; ?>
                </div>
                <div class="span6 sospensions-wrapper">
                    <?php if ($this->sospensions) { ?>
                        <h3>Elenco sospensioni dell'abbonamento</h3>
                        <?php foreach ($this->sospensions as $sos) { ?>
                            <div class='sospension row-fluid'>
                                <div class='span4'>
                                    <label for='jformSubscription[sospension][<?php echo $sos->idSospension ?>][startDate]'>Data di inizio</label>
                                    <input type='text' name='jformSubscription[sospension][<?php echo $sos->idSospension ?>][startDate]' id='jformSubscription[sospension][<?php echo $sos->idSospension ?>][startDate]' value='<?php echo $sos->startDate ?>' />
                                </div>
                                <div class='span4'>
                                    <label for='jformSubscription[sospension][<?php echo $sos->idSospension ?>][endDate]'>Data di fine</label>
                                    <input type='text' name='jformSubscription[sospension][<?php echo $sos->idSospension ?>][endDate]' id='jformSubscription[sospension][<?php echo $sos->idSospension ?>][endDate]' value='<?php echo $sos->endDate ?>' />
                                </div>
                                <div class='span2'>
                                    <label for='jformSubscription[sospension][<?php echo $sos->idSospension ?>][closed]'>Terminata?</label>
                                    <input type='checkbox' name='jformSubscription[sospension][<?php echo $sos->idSospension ?>][closed]' id='jformSubscription[sospension][<?php echo $sos->idSospension ?>][closed]' value='1' <?php echo $sos->closed ? "checked='checked'" : null ?> />
                                </div>
                                <div class='span2'>
                                    <a href='javascript:void(0);' class='delete-sospension' data-idsosp='<?php echo $sos->idSospension ?>'>Elimina</a>
                                </div>
                            </div>
                        <?php } ?>
                    <?php } ?>
                </div>
            </div>
        </fieldset>
    </div>

    <input type="hidden" name="idUser" value="<?php echo $this->item[0]->idUser ?>"/>
    <input type="hidden" name="task" value=""/>
    <?php echo JHtml::_('form.token'); ?>
</form>
<style>
    .sospensions-wrapper .sospension {
        display: flex;
        flex-wrap: wrap;
        align-items: center;
    }
    .sospensions-wrapper .sospension + .sospension {
        margin-top: 15px; padding-top: 15px; border-top: 1px solid #DDD;
    } 
</style>
<script>
    jQuery(function ($) {
        $(document).on("click", ".delete-sospension", function () {
            var $this = $(this);
            var $idSospension = $this.data("idsosp");
            if (confirm("Eliminare la sospensione?")) {
                $.ajax({
                    url: "index.php?option=com_crossfit&task=sospensions.removeSospension&format=raw",
                    method: "POST",
                    dataType: "json",
                    data: {
                        id: $idSospension
                    }
                }).done(function (response) {
                    if (response.success) {
                        $this.parents(".sospension").slideUp(200, function () {
                            $(this).remove();
                        });
                    } else {
                        alert("Error:" + response.message);
                    }
                });
            }
            return false;
        });
    });
</script>