<?php

defined('_JEXEC') or die('Restricted access');

class CrossfitControllerUsers extends JControllerLegacy {

    public function getModel($name = 'Users', $prefix = 'CrossfitModel', $config = array('ignore_request' => true)) {
        return parent::getModel($name, $prefix, $config);
    }

    public function publish() {
        $model = $this->getModel();
        $model->publish();
    }

    public function unpublish() {
        $model = $this->getModel();
        $model->unpublish();
    }

    public function edit() {
        $id = JRequest::getVar("cid");

        $mainframe = JFactory::getApplication();
        $mainframe->redirect("index.php?option=com_crossfit&view=subscriptions&layout=edit&id=" . $id[0]);
    }

    public function delete() {
        $ids = JRequest::getVar("cid");

        if ($ids) {
            $model = $this->getModel();
            foreach ($ids as $id) {
                $model->delete($id);
            }
        }

        $mainframe = JFactory::getApplication();
        $mainframe->enqueueMessage(count($ids) . (count($ids) == 1 ? ' utente eliminato' : ' utenti eliminati'));
        $mainframe->redirect("index.php?option=com_crossfit&view=users");
    }

    public function export() {
        $model = $this->getModel();
        $model->export();

        $mainframe = JFactory::getApplication();
        $mainframe->redirect("index.php?option=com_crossfit&view=users");
    }

    public function resendEmail() {
        $model = $this->getModel();
        $model->resendEmail();
        
        JFactory::getApplication()->redirect("index.php?option=com_crossfit&view=users");
    }

    public function sendEmailToSubscribers() {
        $model = $this->getModel();
        $model->sendEmailToSubscribers();
    }

}
