<?php

defined('_JEXEC') or die('Restricted access');

class CrossfitModelUsersubscription extends JModelList {

    var $insertedId = null;

    public function __construct($config = array()) {
        parent::__construct($config);
    }

    public function getItem() {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select('*')->from($db->quoteName('#__crossfit_subscriptions_users'))->where('idSU = ' . (int) JRequest::getVar('idSU'));

        $db->setQuery($query);

        return $db->loadObjectList();
    }

    public function getForm($data = array(), $loadData = true) {
        $form = $this->loadForm('com_crossfit.user.subscription', 'user.subscription', array('control' => 'jformSubscription', 'load_data' => $loadData));

        if (empty($form)) {
            return false;
        }

        return $form;
    }

    public function delete($id = null) {
        if (!$id)
            return;

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->delete('#__crossfit_subscriptions_users')->where('idSU = ' . $query->quote($id));

        $db->setQuery($query);

        return $db->execute();
    }

    public function save() {
        $db = JFactory::getDbo();
        $post = JRequest::get('post');
        $post = $post['jformSubscription'];

        if (trim($post['dataInizioS']) != "") {
            $post['dataInizioS'] = explode("/", $post['dataInizioS']);
            $post['dataInizioS'] = "{$post['dataInizioS'][2]}-{$post['dataInizioS'][1]}-{$post['dataInizioS'][0]}";
        } else {
            $post['dataInizioS'] = null;
        }
        if (trim($post['dataScadenzaReale']) != "") {
            $post['dataScadenzaReale'] = explode("/", $post['dataScadenzaReale']);
            $post['dataScadenzaReale'] = "{$post['dataScadenzaReale'][2]}-{$post['dataScadenzaReale'][1]}-{$post['dataScadenzaReale'][0]}";
        } else {
            $post['dataScadenzaReale'] = null;
        }
        if (trim($post['dataAcconto']) != "") {
            $post['dataAcconto'] = explode("/", $post['dataAcconto']);
            $post['dataAcconto'] = "{$post['dataAcconto'][2]}-{$post['dataAcconto'][1]}-{$post['dataAcconto'][0]}";
        } else {
            $post['dataAcconto'] = null;
        }

        $data = new stdClass;
        $data->idSU = $post['idSU'];
        $data->idSubscription = $post['idSubscription'];
        $data->dataInizio = $post['dataInizioS'];
        $data->dataScadenzaReale = $post['dataScadenzaReale'];
        $data->dataAcconto = $post['dataAcconto'];
        $data->giorniAggiuntivi = $post['giorniAggiuntivi'];
        $data->prezzo = $post['prezzo'];
        $data->pagato = $post['pagatoS'];
        $data->sospeso = $post['sospeso'];
        $data->note = $post['note'];
        $data->allenamentoAggiuntivo = $post['allenamentoAggiuntivo'];
        $data->giorniSospensione = $post['giorniSospensione'];

        $oldSospeso = $db->setQuery("SELECT sospeso FROM #__crossfit_subscriptions_users WHERE idSU = {$post['idSU']}")->loadResult();
        if ($post['sospeso'] && $oldSospeso != $post['sospeso'] && !$oldSospeso) {
            $sospdata = new stdClass();
            $sospdata->idSubscription = $post['idSU'];
            if (date("w") == 1) {
                $sospdata->startDate = date("Y-m-d 00:00:00");
            } else {
                $sospdata->startDate = date("Y-m-d 00:00:00", strtotime("last monday"));
            }
            $sospdata->endDate = '0000-00-00 00:00:00';
            $db->insertObject('#__crossfit_subscriptions_sospensions', $sospdata, 'idSospension', true);
        } elseif ($oldSospeso != $post['sospeso'] && $oldSospeso) {
            $idSosp = $db->setQuery("SELECT idSospension FROM #__crossfit_subscriptions_sospensions WHERE idSubscription = {$post['idSU']} AND closed = 0 ORDER by startDate DESC LIMIT 0,1")->loadResult();
            if ($idSosp) {
                if (date("w") == 0) {
                    $endDate = date("Y-m-d 23:59:59");
                } else {
                    $endDate = date("Y-m-d 23:59:59", strtotime("last sunday"));
                }
                $sosquery = "UPDATE #__crossfit_subscriptions_sospensions SET endDate = '" . $endDate . "', closed = 1 WHERE idSospension = {$idSosp}";
            } else {
                if (date("w") == 1) {
                    $startDate = date("Y-m-d 00:00:00");
                } else {
                    $startDate = date("Y-m-d 00:00:00", strtotime("last monday"));
                }
                if (date("w") == 0) {
                    $endDate = date("Y-m-d 23:59:59");
                } else {
                    $endDate = date("Y-m-d 23:59:59", strtotime("next sunday"));
                }
                $sosquery = "INSERT INTO #__crossfit_subscriptions_sospensions (idSubscription, startDate, endDate, closed) VALUES ({$post['idSU']}, '{$startDate}', '{$endDate}', 1)";
            }
            $db->setQuery($sosquery)->execute();
        }

        if ($post['sospension']) {
            foreach ($post['sospension'] as $id => $val) {
                if ($idSosp != $id) {
                    $stdObj = new stdClass();
                    $stdObj->idSospension = $id;
                    $stdObj->startDate = date("Y-m-d 00:00:00", strtotime($val['startDate']));
                    $stdObj->endDate = strtotime($val['endDate']) > 0 ? date("Y-m-d 23:59:59", strtotime($val['endDate'])) : "0000-00-00 00:00:00";
                    $db->updateObject("#__crossfit_subscriptions_sospensions", $stdObj, 'idSospension');
                }
            }
        }

        $days = $db->setQuery("SELECT SUM(DATEDIFF(endDate, startDate)) FROM #__crossfit_subscriptions_sospensions WHERE endDate > startDate AND idSubscription = {$post['idSU']}")->loadResult();
        $data->giorniSospensione = $days;

        return $db->updateObject('#__crossfit_subscriptions_users', $data, idSU, true);
    }

}
