<?php

defined('_JEXEC') or die('Restricted access');

class CrossfitViewSubscriptionsusers extends JViewLegacy {

    function display($tpl = null) {
        $this->items = $this->get('Items');
        $this->pagination = $this->get('Pagination');
        $this->state = $this->get('State');
        $this->filterForm = $this->get('FilterForm');
        $this->activeFilters = $this->get('ActiveFilters');

        if (count($errors = $this->get('Errors'))) {
            JError::raiseError(500, implode('<br />', $errors));

            return false;
        }

        $this->addToolBar();

        parent::display($tpl);
    }

    protected function addToolBar() {
        $title = "Gestione abbonamenti";

        if ($this->pagination->total) {
            $title .= " (" . $this->pagination->total . ")";
        }

        JToolBarHelper::title($title, 'users');
        JToolBarHelper::deleteList('', 'users.delete');
        JToolBarHelper::editList('user.edit');
        JToolBarHelper::addNew('user.add');
    }

}
