<?php
defined('_JEXEC') or die;

JHtml::_('formbehavior.chosen', 'select');

$listOrder = $this->escape($this->state->get('list.ordering'));
$listDirn = $this->escape($this->state->get('list.direction'));
?>
<form action="index.php?option=com_crossfit&view=users" method="post" id="adminForm" name="adminForm">
    <div class="row-fluid">
        <div class="span12">
            Ricerca iscritto
            <?php echo JLayoutHelper::render('joomla.searchtools.default', array('view' => $this)); ?>
        </div>
    </div>
    <table class="table table-striped table-hover">
        <thead>
            <tr>
                <th width="1%">#</th>
                <th width="2%">
                    <?php echo JHtmlGrid::checkall() ?>
                </th>
                <th width="">
                    <?php echo JHtmlGrid::sort('Nome', 'nome', $listDirn, $listOrder); ?>
                </th>
                <th width="10%">
                    <?php echo JHtmlGrid::sort('Email', 'email', $listDirn, $listOrder); ?>
                </th>
                <th width="10%">
                    <?php echo JHtmlGrid::sort('Codice Fiscale', 'codiceFiscale', $listDirn, $listOrder); ?>
                </th>
                <th width="10%">
                    Telefono
                </th>
                <th width="10%">
                    <?php echo JHtmlGrid::sort('Data di Nascita', 'dataNascita', $listDirn, $listOrder); ?>
                </th>
                <th width="7%" style="text-align: center">
                    Recuperi
                </th>
                <th width="7%" style="text-align: left">
                    Box
                </th>
                <th width="7%" style="text-align: center">
                    <?php echo JHtmlGrid::sort('Abbonamento', 'dataScadenzaAbbonamento', $listDirn, $listOrder); ?>
                </th>
                <th width="5%" style="text-align: center">
                    <?php echo JHtmlGrid::sort('Iscrizione', 'dataScadenzaIscrizione', $listDirn, $listOrder); ?>
                </th>
                <th width="5%" style="text-align: center">
                    <?php echo JHtmlGrid::sort('Certificato', 'dataCertificato', $listDirn, $listOrder); ?>
                </th>
                <?php if (JFactory::getUser()->authorise('crossfit.edit', 'com_crossfit')) { ?>
                    <th width="5%" style="text-align: center">
                        <?php echo JHtmlGrid::sort('Attivo', 'published', $listDirn, $listOrder); ?>
                    </th>
                <?php } ?>
                <th width="5%" style="text-align: center">
                    <?php echo JHtmlGrid::sort('ID', 'idUser', $listDirn, $listOrder); ?>
                </th>
            </tr>
        </thead>
        <tfoot>
            <tr>
                <td colspan="14">
                    <?php echo $this->pagination->getListFooter(); ?>
                </td>
            </tr>
        </tfoot>
        <tbody>
            <?php if (!empty($this->items)) : ?>
                <?php
                foreach ($this->items as $i => $row) :
                    $link = JRoute::_('index.php?option=com_crossfit&view=user&layout=edit&idUser=' . $row->idUser);
                    ?>
                    <tr>
                        <td><?php echo $this->pagination->getRowOffset($i); ?></td>
                        <td>
                            <?php echo JHtml::_('grid.id', $i, $row->idUser); ?>
                        </td>
                        <td>
                            <a href="<?php echo $link; ?>" title="Nome utente">
                                <?php echo $row->nome ?> <?php echo $row->cognome ?>
                            </a>
                        </td>
                        <td>
                            <?php echo $row->email ?>
                        </td>
                        <td>
                            <?php echo $row->codiceFiscale ?>
                        </td>
                        <td>
                            <?php echo $row->telefono ?>
                        </td>
                        <td>
                            <?php echo date("d/m/Y", strtotime($row->dataNascita)) ?>
                        </td>
                        <td class="center">
                            <?php echo CrossfitHelper::calcoloRecuperi($row->idUser, $row->idUserJoomla) ?>
                        </td>
                        <td>
                            <?php echo $this->palestre[$row->idPalestra] ?>
                        </td>
                        <td style="text-align: center">
                            <?php $dataScadenzaAbbonamento = CrossfitHelper::getDataScadenzaAbbonamento($row->idUser); ?>
                            <?php if ($dataScadenzaAbbonamento == "") { ?>
                                <a href='javascript:void(0);' class='btn btn-micro hasTooltip' data-original-title='Abbonamento non effettuata'><span class='icon-unpublish'></span></a>
                            <?php } elseif (time() > strtotime($dataScadenzaAbbonamento)) { ?>
                                <a href='javascript:void(0);' class='btn btn-micro hasTooltip' data-original-title='Abbonamento scaduto il <?php echo date('d/m/Y', strtotime($dataScadenzaAbbonamento)) ?>'><span class='icon-pending'></span></a>
                            <?php } elseif (time() < strtotime($dataScadenzaAbbonamento) && CrossfitHelper::isSospeso($row->idUser)) { ?>
                                <a href='javascript:void(0);' class='btn btn-micro hasTooltip' data-original-title='Abbonamento sospeso (Data di scadenza: <?php echo date('d/m/Y', strtotime($dataScadenzaAbbonamento)) ?>)'><span class='icon-clock'></span></a>
                            <?php } elseif (time() < strtotime($dataScadenzaAbbonamento)) { ?>
                                <a href='javascript:void(0);' class='btn btn-micro hasTooltip' data-original-title='Abbonamento attivo (Scadenza: <?php echo date('d/m/Y', strtotime($dataScadenzaAbbonamento)) ?>)'><span class='icon-publish'></span></a>
                            <?php } ?>
                        </td>
                        <td style="text-align: center">
                            <?php $dataScadenzaIscrizione = CrossfitHelper::getDataScadenzaIscrizione($row->idUser); ?>
                            <?php if ($dataScadenzaIscrizione == "") { ?>
                                <a href='javascript:void(0);' class='btn btn-micro hasTooltip' data-original-title='Iscrizione non effettuata'><span class='icon-unpublish'></span></a>
                            <?php } elseif (time() > strtotime($dataScadenzaIscrizione)) { ?>
                                <a href='javascript:void(0);' class='btn btn-micro hasTooltip' data-original-title='Iscrizione scaduta il <?php echo date('d/m/Y', strtotime($dataScadenzaIscrizione)) ?>'><span class='icon-pending'></span></a>
                            <?php } elseif (time() < strtotime($dataScadenzaIscrizione)) { ?>
                                <a href='javascript:void(0);' class='btn btn-micro hasTooltip' data-original-title='Iscrizione attiva (Scadenza: <?php echo date('d/m/Y', strtotime($dataScadenzaIscrizione)) ?>)'><span class='icon-publish'></span></a>
                            <?php } ?>
                        </td>
                        <td style="text-align: center">
                            <?php if ($row->dataCertificato == "") { ?>
                                <a href='javascript:void(0);' class='btn btn-micro hasTooltip' data-original-title='Certificato non consegnato'><span class='icon-unpublish'></span></a>
                            <?php } elseif (time() > strtotime($row->dataCertificato . " + 1 year")) { ?>
                                <a href='javascript:void(0);' class='btn btn-micro hasTooltip' data-original-title='Certificato scaduto il <?php echo date('d/m/Y', strtotime($row->dataCertificato . " + 1 year")) ?>'><span class='icon-pending'></span></a>
                            <?php } elseif (time() <= strtotime($row->dataCertificato . " + 1 year")) { ?>
                                <a href='javascript:void(0);' class='btn btn-micro hasTooltip' data-original-title='Certificato valido (Scadenza: <?php echo date('d/m/Y', strtotime($row->dataCertificato . " + 1 year")) ?>)'><span class='icon-publish'></span></a>
                            <?php } ?>
                        </td>

                        <?php if (JFactory::getUser()->authorise('crossfit.edit', 'com_crossfit')) { ?>
                            <td style="text-align: center">
                                <?php echo JHtml::_('jgrid.published', $row->published, $i, 'users.', true, 'cb'); ?>
                            </td>
                        <?php } ?>
                        <td style="text-align: center">
                            <?php echo $row->idUser ?> <small>[<?php echo $row->idUserJoomla ?>]</small>
                        </td>
                    </tr>
                <?php endforeach; ?>
            <?php endif; ?>
        </tbody>
    </table>
    <input type="hidden" name="task" value=""/>
    <input type="hidden" name="boxchecked" value="0"/>
    <input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>"/>
    <input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>"/>
    <?php echo JHtml::_('form.token'); ?>

    <script>
        Joomla.submitbutton = function submitbutton(pressbutton) {
            if (pressbutton === 'users.export') {
                document.adminForm.task.value = pressbutton;
                submitform(pressbutton);
                jQuery("input[name='task']").val("");
            } else if (pressbutton === 'users.resendEmail') {
                document.adminForm.task.value = pressbutton;
                submitform(pressbutton);
                jQuery("input[name='task']").val("");
            } else {
                document.adminForm.task.value = pressbutton;
                submitform(pressbutton);
            }
        }
    </script>
    <style>
        .table > tbody > tr > td {
            white-space: nowrap; overflow: hidden; text-overflow: ellipsis;
        }
    </style>
</form>